// Models.swift
//
// Generated by swagger-codegen
// https://github.com/swagger-api/swagger-codegen
//

import Foundation

protocol JSONEncodable {
    func encodeToJSON() -> Any
}

public enum ErrorResponse : Error {
    case Error(Int, Data?, Error)
}

open class Response<T> {
    open let statusCode: Int
    open let header: [String: String]
    open let body: T?

    public init(statusCode: Int, header: [String: String], body: T?) {
        self.statusCode = statusCode
        self.header = header
        self.body = body
    }

    public convenience init(response: HTTPURLResponse, body: T?) {
        let rawHeader = response.allHeaderFields
        var header = [String:String]()
        for (key, value) in rawHeader {
            header[key as! String] = value as? String
        }
        self.init(statusCode: response.statusCode, header: header, body: body)
    }
}

private var once = Int()
class Decoders {
    static fileprivate var decoders = Dictionary<String, ((AnyObject) -> AnyObject)>()

    static func addDecoder<T>(clazz: T.Type, decoder: @escaping ((AnyObject) -> T)) {
        let key = "\(T.self)"
        decoders[key] = { decoder($0) as AnyObject }
    }

    static func decode<T>(clazz: T.Type, discriminator: String, source: AnyObject) -> T {
        let key = discriminator;
        if let decoder = decoders[key] {
            return decoder(source) as! T
        } else {
            fatalError("Source \(source) is not convertible to type \(clazz): Maybe swagger file is insufficient")
        }
    }

    static func decode<T>(clazz: [T].Type, source: AnyObject) -> [T] {
        let array = source as! [AnyObject]
        return array.map { Decoders.decode(clazz: T.self, source: $0) }
    }

    static func decode<T, Key: Hashable>(clazz: [Key:T].Type, source: AnyObject) -> [Key:T] {
        let sourceDictionary = source as! [Key: AnyObject]
        var dictionary = [Key:T]()
        for (key, value) in sourceDictionary {
            dictionary[key] = Decoders.decode(clazz: T.self, source: value)
        }
        return dictionary
    }

    static func decode<T>(clazz: T.Type, source: AnyObject) -> T {
        initialize()
        if T.self is Int32.Type && source is NSNumber {
            return source.int32Value as! T;
        }
        if T.self is Int64.Type && source is NSNumber {
            return source.int64Value as! T;
        }
        if T.self is UUID.Type && source is String {
            return UUID(uuidString: source as! String) as! T
        }
        if source is T {
            return source as! T
        }
        if T.self is Data.Type && source is String {
            return Data(base64Encoded: source as! String) as! T
        }

        let key = "\(T.self)"
        if let decoder = decoders[key] {
           return decoder(source) as! T
        } else {
            fatalError("Source \(source) is not convertible to type \(clazz): Maybe swagger file is insufficient")
        }
    }

    static func decodeOptional<T>(clazz: T.Type, source: AnyObject?) -> T? {
        if source is NSNull {
            return nil
        }
        return source.map { (source: AnyObject) -> T in
            Decoders.decode(clazz: clazz, source: source)
        }
    }

    static func decodeOptional<T>(clazz: [T].Type, source: AnyObject?) -> [T]? {
        if source is NSNull {
            return nil
        }
        return source.map { (someSource: AnyObject) -> [T] in
            Decoders.decode(clazz: clazz, source: someSource)
        }
    }

    static func decodeOptional<T, Key: Hashable>(clazz: [Key:T].Type, source: AnyObject?) -> [Key:T]? {
        if source is NSNull {
            return nil
        }
        return source.map { (someSource: AnyObject) -> [Key:T] in
            Decoders.decode(clazz: clazz, source: someSource)
        }
    }

    private static var __once: () = {
        let formatters = [
            "yyyy-MM-dd",
            "yyyy-MM-dd'T'HH:mm:ssZZZZZ",
            "yyyy-MM-dd'T'HH:mm:ss.SSSZZZZZ",
            "yyyy-MM-dd'T'HH:mm:ss'Z'",
            "yyyy-MM-dd'T'HH:mm:ss.SSS"
        ].map { (format: String) -> DateFormatter in
            let formatter = DateFormatter()
            formatter.dateFormat = format
            return formatter
        }
        // Decoder for Date
        Decoders.addDecoder(clazz: Date.self) { (source: AnyObject) -> Date in
           if let sourceString = source as? String {
                for formatter in formatters {
                    if let date = formatter.date(from: sourceString) {
                        return date
                    }
                }
            }
            if let sourceInt = source as? Int {
                // treat as a java date
                return Date(timeIntervalSince1970: Double(sourceInt / 1000) )
            }
            fatalError("formatter failed to parse \(source)")
        } 

        // Decoder for [Alerte]
        Decoders.addDecoder(clazz: [Alerte].self) { (source: AnyObject) -> [Alerte] in
            return Decoders.decode(clazz: [Alerte].self, source: source)
        }
        // Decoder for Alerte
        Decoders.addDecoder(clazz: Alerte.self) { (source: AnyObject) -> Alerte in
            let sourceDictionary = source as! [AnyHashable: Any]

            let instance = Alerte()
            instance.id = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["id"] as AnyObject?)
            if let etatCourant = sourceDictionary["etatCourant"] as? String { 
                instance.etatCourant = Alerte.EtatCourant(rawValue: (etatCourant))
            }
            
            if let typeAlerte = sourceDictionary["typeAlerte"] as? String { 
                instance.typeAlerte = Alerte.TypeAlerte(rawValue: (typeAlerte))
            }
            
            instance.evenements = Decoders.decodeOptional(clazz: Array.self, source: sourceDictionary["evenements"] as AnyObject?)
            instance.foyerEmetteur = Decoders.decodeOptional(clazz: Foyer.self, source: sourceDictionary["foyerEmetteur"] as AnyObject?)
            instance.foyerImpacte = Decoders.decodeOptional(clazz: Foyer.self, source: sourceDictionary["foyerImpacte"] as AnyObject?)
            instance.dateCreated = Decoders.decodeOptional(clazz: Date.self, source: sourceDictionary["dateCreated"] as AnyObject?)
            return instance
        }


        // Decoder for [AlerteMairie]
        Decoders.addDecoder(clazz: [AlerteMairie].self) { (source: AnyObject) -> [AlerteMairie] in
            return Decoders.decode(clazz: [AlerteMairie].self, source: source)
        }
        // Decoder for AlerteMairie
        Decoders.addDecoder(clazz: AlerteMairie.self) { (source: AnyObject) -> AlerteMairie in
            let sourceDictionary = source as! [AnyHashable: Any]

            let instance = AlerteMairie()
            instance.id = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["id"] as AnyObject?)
            instance.dateDebutAlerte = Decoders.decodeOptional(clazz: Date.self, source: sourceDictionary["dateDebutAlerte"] as AnyObject?)
            instance.fateFinAlerte = Decoders.decodeOptional(clazz: Date.self, source: sourceDictionary["fateFinAlerte"] as AnyObject?)
            instance.texteAlerte = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["texteAlerte"] as AnyObject?)
            instance.quartiersAlertes = Decoders.decodeOptional(clazz: Array.self, source: sourceDictionary["quartiersAlertes"] as AnyObject?)
            return instance
        }


        // Decoder for [Commune]
        Decoders.addDecoder(clazz: [Commune].self) { (source: AnyObject) -> [Commune] in
            return Decoders.decode(clazz: [Commune].self, source: source)
        }
        // Decoder for Commune
        Decoders.addDecoder(clazz: Commune.self) { (source: AnyObject) -> Commune in
            let sourceDictionary = source as! [AnyHashable: Any]

            let instance = Commune()
            instance.codeInsee = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["codeInsee"] as AnyObject?)
            instance.nom = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["nom"] as AnyObject?)
            instance.codePostaux = Decoders.decodeOptional(clazz: Array.self, source: sourceDictionary["codePostaux"] as AnyObject?)
            instance.latitude = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["latitude"] as AnyObject?)
            instance.longitude = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["longitude"] as AnyObject?)
            return instance
        }


        // Decoder for [Credentials]
        Decoders.addDecoder(clazz: [Credentials].self) { (source: AnyObject) -> [Credentials] in
            return Decoders.decode(clazz: [Credentials].self, source: source)
        }
        // Decoder for Credentials
        Decoders.addDecoder(clazz: Credentials.self) { (source: AnyObject) -> Credentials in
            let sourceDictionary = source as! [AnyHashable: Any]

            let instance = Credentials()
            instance.idFoyer = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["idFoyer"] as AnyObject?)
            instance.password = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["password"] as AnyObject?)
            return instance
        }


        // Decoder for [Evenement]
        Decoders.addDecoder(clazz: [Evenement].self) { (source: AnyObject) -> [Evenement] in
            return Decoders.decode(clazz: [Evenement].self, source: source)
        }
        // Decoder for Evenement
        Decoders.addDecoder(clazz: Evenement.self) { (source: AnyObject) -> Evenement in
            let sourceDictionary = source as! [AnyHashable: Any]

            let instance = Evenement()
            instance.dateCreated = Decoders.decodeOptional(clazz: Date.self, source: sourceDictionary["dateCreated"] as AnyObject?)
            instance.nomFoyerEmetteur = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["nomFoyerEmetteur"] as AnyObject?)
            if let typeEvenement = sourceDictionary["typeEvenement"] as? String { 
                instance.typeEvenement = Evenement.TypeEvenement(rawValue: (typeEvenement))
            }
            
            return instance
        }


        // Decoder for [Foyer]
        Decoders.addDecoder(clazz: [Foyer].self) { (source: AnyObject) -> [Foyer] in
            return Decoders.decode(clazz: [Foyer].self, source: source)
        }
        // Decoder for Foyer
        Decoders.addDecoder(clazz: Foyer.self) { (source: AnyObject) -> Foyer in
            let sourceDictionary = source as! [AnyHashable: Any]

            let instance = Foyer()
            instance.id = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["id"] as AnyObject?)
            instance.identifiantUnique = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["identifiantUnique"] as AnyObject?)
            instance.nom = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["nom"] as AnyObject?)
            instance.numeroTelephone = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["numeroTelephone"] as AnyObject?)
            instance.dateCreated = Decoders.decodeOptional(clazz: Date.self, source: sourceDictionary["dateCreated"] as AnyObject?)
            instance.lastUpdated = Decoders.decodeOptional(clazz: Date.self, source: sourceDictionary["lastUpdated"] as AnyObject?)
            instance.immeuble = Decoders.decodeOptional(clazz: Immeuble.self, source: sourceDictionary["immeuble"] as AnyObject?)
            instance.uuid = Decoders.decodeOptional(clazz: Array.self, source: sourceDictionary["uuid"] as AnyObject?)
            instance.abonnementQuartier = Decoders.decodeOptional(clazz: Array.self, source: sourceDictionary["abonnementQuartier"] as AnyObject?)
            instance.utilisateurs = Decoders.decodeOptional(clazz: Array.self, source: sourceDictionary["utilisateurs"] as AnyObject?)
            return instance
        }


        // Decoder for [GetFoyerResponse]
        Decoders.addDecoder(clazz: [GetFoyerResponse].self) { (source: AnyObject) -> [GetFoyerResponse] in
            return Decoders.decode(clazz: [GetFoyerResponse].self, source: source)
        }
        // Decoder for GetFoyerResponse
        Decoders.addDecoder(clazz: GetFoyerResponse.self) { (source: AnyObject) -> GetFoyerResponse in
            let sourceDictionary = source as! [AnyHashable: Any]

            let instance = GetFoyerResponse()
            instance.immeuble = Decoders.decodeOptional(clazz: Int32.self, source: sourceDictionary["immeuble"] as AnyObject?)
            instance.foyers = Decoders.decodeOptional(clazz: Array.self, source: sourceDictionary["foyers"] as AnyObject?)
            return instance
        }


        // Decoder for [IdentifiantUtilisateur]
        Decoders.addDecoder(clazz: [IdentifiantUtilisateur].self) { (source: AnyObject) -> [IdentifiantUtilisateur] in
            return Decoders.decode(clazz: [IdentifiantUtilisateur].self, source: source)
        }
        // Decoder for IdentifiantUtilisateur
        Decoders.addDecoder(clazz: IdentifiantUtilisateur.self) { (source: AnyObject) -> IdentifiantUtilisateur in
            let sourceDictionary = source as! [AnyHashable: Any]

            let instance = IdentifiantUtilisateur()
            instance.identifiantUtilisateur = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["identifiantUtilisateur"] as AnyObject?)
            return instance
        }


        // Decoder for [Immeuble]
        Decoders.addDecoder(clazz: [Immeuble].self) { (source: AnyObject) -> [Immeuble] in
            return Decoders.decode(clazz: [Immeuble].self, source: source)
        }
        // Decoder for Immeuble
        Decoders.addDecoder(clazz: Immeuble.self) { (source: AnyObject) -> Immeuble in
            let sourceDictionary = source as! [AnyHashable: Any]

            let instance = Immeuble()
            instance.id = Decoders.decodeOptional(clazz: Int32.self, source: sourceDictionary["id"] as AnyObject?)
            instance.adresse = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["adresse"] as AnyObject?)
            instance.latitude = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["latitude"] as AnyObject?)
            instance.longitude = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["longitude"] as AnyObject?)
            return instance
        }


        // Decoder for [Quartier]
        Decoders.addDecoder(clazz: [Quartier].self) { (source: AnyObject) -> [Quartier] in
            return Decoders.decode(clazz: [Quartier].self, source: source)
        }
        // Decoder for Quartier
        Decoders.addDecoder(clazz: Quartier.self) { (source: AnyObject) -> Quartier in
            let sourceDictionary = source as! [AnyHashable: Any]

            let instance = Quartier()
            instance.id = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["id"] as AnyObject?)
            instance.nom = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["nom"] as AnyObject?)
            instance.alertes = Decoders.decodeOptional(clazz: Array.self, source: sourceDictionary["alertes"] as AnyObject?)
            instance.marie = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["marie"] as AnyObject?)
            instance.tous = Decoders.decodeOptional(clazz: Bool.self, source: sourceDictionary["tous"] as AnyObject?)
            return instance
        }


        // Decoder for [Utilisateur]
        Decoders.addDecoder(clazz: [Utilisateur].self) { (source: AnyObject) -> [Utilisateur] in
            return Decoders.decode(clazz: [Utilisateur].self, source: source)
        }
        // Decoder for Utilisateur
        Decoders.addDecoder(clazz: Utilisateur.self) { (source: AnyObject) -> Utilisateur in
            let sourceDictionary = source as! [AnyHashable: Any]

            let instance = Utilisateur()
            instance.id = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["id"] as AnyObject?)
            instance.nom = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["nom"] as AnyObject?)
            instance.prenom = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["prenom"] as AnyObject?)
            return instance
        }


        // Decoder for [Version]
        Decoders.addDecoder(clazz: [Version].self) { (source: AnyObject) -> [Version] in
            return Decoders.decode(clazz: [Version].self, source: source)
        }
        // Decoder for Version
        Decoders.addDecoder(clazz: Version.self) { (source: AnyObject) -> Version in
            let sourceDictionary = source as! [AnyHashable: Any]

            let instance = Version()
            instance.needUpdate = Decoders.decodeOptional(clazz: Bool.self, source: sourceDictionary["needUpdate"] as AnyObject?)
            return instance
        }
    }()

    static fileprivate func initialize() {
        _ = Decoders.__once
    }
}
